-- CREACION DE LAS TABLAS

--TABLAS AUXILIARES
--TABLA LOG
CREATE TABLE  "SCCI_LOG" 
   (	"IDLOG" NUMBER(10,0) NOT NULL, 
	"TABLA" VARCHAR(255) NOT NULL,
    "ACCION" VARCHAR(500) NOT NULL,
	"FECHA" DATE NOT NULL,
    "RESULTADO" VARCHAR(1000) NOT NULL,
	 CONSTRAINT "SCCI_LOG_PK" PRIMARY KEY ("IDLOG")
   )
/


-- TABLAS DEL MDULO DE GESTIN DE PROPIETARIOS Y SUS PARCELAS
-- PROPIETARIOS
CREATE TABLE  "SCCI_PROPIETARIO" 
   (	"IDPROPIETARIO" NUMBER(10,0) NOT NULL, 
	"NOMBRE" VARCHAR(255) NOT NULL, 
	"APELLIDO1" VARCHAR(255) NOT NULL, 
	"APELLIDO2" VARCHAR(255) NULL , 
    "MAIL" VARCHAR(100), 
	"TELEFONO" VARCHAR(100), 
	"FECHAREGISTRO" DATE NOT NULL,
    "FECHABAJA" DATE NULL,
    "ACTIVO" NUMBER(1) NOT NULL,
	CONSTRAINT "SCCI_PROPIETARIO_PK" PRIMARY KEY ("IDPROPIETARIO")
   )
/
-- PARCELAS
CREATE TABLE  "SCCI_PARCELA" 
   (	"IDPARCELA" NUMBER(10,0) NOT NULL, 
	"IDPROPIETARIO" NUMBER(10,0) NOT NULL, 
	"IDRIESGO" NUMBER(10,0) NULL,
    "ELEVACION" NUMBER(10,0) NOT NULL,
    "SUPERFICIE" NUMBER(10,0) NOT NULL,
    "COORDENADAS" VARCHAR(10) NOT NULL,
    "ACTIVO" NUMBER(1) NOT NULL,
	 CONSTRAINT "SCCI_PARCELA_PK" PRIMARY KEY ("IDPARCELA"),
     CONSTRAINT "SCCI_PROPIETARIO_FK_PARCELA" FOREIGN KEY ("IDPROPIETARIO") REFERENCES  "SCCI_PROPIETARIO" ("IDPROPIETARIO") 
   )

/


-- TABLAS DEL MDULO DE RECOGIDA DE INFORMACIN
--VEGETACION
CREATE TABLE  "SCCI_VEGETACION" 
   (	"IDVEGETACION" NUMBER(10,0) NOT NULL, 
	"CLASIFICACION" VARCHAR(255), 
    "ESPECIE" VARCHAR(255),
    "RECUBRIMIENTO" NUMBER(10,0),
    "ALTURA" NUMBER(10,0),
    "RECUBRIMIENTOSOTO" NUMBER(10,0),
    "ALTURASOTO" NUMBER(10,0),
    "ACTIVO" NUMBER(1) NOT NULL,
	 CONSTRAINT "SCCI_VEGETACION_PK" PRIMARY KEY ("IDVEGETACION")
   )
/
--DENSIDAD
CREATE TABLE  "SCCI_DENSIDAD" 
   (	"IDDENSIDAD" NUMBER(10,0) NOT NULL, 
    "DISTANCIAMEDIA" NUMBER(10,2),
    "DIAMETRORAICES" VARCHAR(2),
    "ACTIVO" NUMBER(1) NOT NULL,
	 CONSTRAINT "SCCI_DENSIDAD_PK" PRIMARY KEY ("IDDENSIDAD")
   )
/
--PENDIENTE
CREATE TABLE  "SCCI_PENDIENTE" 
   (	"IDPENDIENTE" NUMBER(10,0) NOT NULL, 
	"TIPO" VARCHAR(255), 
    "GRADIENTE" NUMBER(3,0),
    "ACTIVO" NUMBER(1) NOT NULL,
	 CONSTRAINT "SCCI_PENDIENTE_PK" PRIMARY KEY ("IDPENDIENTE")
   )
/
--PLUVIOMETRIA
CREATE TABLE  "SCCI_PLUVIOMETRIA" 
   (	"IDPLUVIOMETRIA" NUMBER(10,0) NOT NULL, 
	"CONDICIONACTUAL" VARCHAR(255), 
    "CONDICIONPASADA" VARCHAR(255),
    "ACTIVO" NUMBER(1) NOT NULL,
	 CONSTRAINT "SCCI_PLUVIOMETRIA_PK" PRIMARY KEY ("IDPLUVIOMETRIA")
   )
/
--EROSIN
CREATE TABLE  "SCCI_EROSION" 
   (	"IDEROSION" NUMBER(10,0) NOT NULL, 
    "AFECTACION" NUMBER(10,0),
    "GRADO" VARCHAR(2),
    "PERIODO" VARCHAR(255),
    "ACTIVO" NUMBER(1) NOT NULL,
	 CONSTRAINT "SCCI_EROSION_PK" PRIMARY KEY ("IDEROSION")
   )
/


-- TABLAS DEL MDULO DE GESTIN DE LAS EMPRESAS
-- TABLA EMPRESA
CREATE TABLE  "SCCI_EMPRESA" 
   (	"IDEMPRESA" NUMBER(10,0) NOT NULL, 
	"NOMBRE" VARCHAR(255) NOT NULL, 
	"CIF" VARCHAR(20) NOT NULL,
    "DIRECCION" VARCHAR(500) NOT NULL,
    "TELEFONO" VARCHAR(20) NOT NULL,
    "HOMOLOGADA" NUMBER(1,0) NULL,
    "ACTIVO" NUMBER(1) NOT NULL,
	 CONSTRAINT "SCCI_EMPRESA_PK" PRIMARY KEY ("IDEMPRESA")
   )
/


-- TABLAS DEL MDULO DE GESTIN DE LAS SUBVENCIONES Y ASIGNACIONES A EMPRESAS
-- PLAN
CREATE TABLE  "SCCI_PLAN" 
   (	"IDPLAN" NUMBER(10,0) NOT NULL, 
	"NOMBRE" VARCHAR(255),
    "ANUALIDAD" VARCHAR (4) NOT NULL,
    "EFECTIVIDAD" NUMBER NULL,
    "ACTIVO" NUMBER(1) NOT NULL,
	 CONSTRAINT "SCCI_PLAN_PK" PRIMARY KEY ("IDPLAN")
   )
/

-- TABLA SUBVENCION
CREATE TABLE  "SCCI_SUBVENCION" 
   (	"IDSUBVENCION" NUMBER(10,0) NOT NULL, 
  	"IDPLAN" NUMBER(10,0) NOT NULL,   
    "IDPETICIONGANADORA" NUMBER(10,0) NULL, 
    "FECHAINICIO" DATE NOT NULL,
    "FECHAFINAL" DATE NULL,
    "ESTADO" NUMBER(2) NOT NULL,
    "IMPORTEMAX" NUMBER(10,2) NOT NULL,
    "GASTOACTUAL" NUMBER (10,2) NULL,
    "ANUALIDAD" NUMBER(10) NOT NULL,
	 CONSTRAINT "SCCI_SUBVENCION_PK" PRIMARY KEY ("IDSUBVENCION"),
     CONSTRAINT "SCCI_PLAN_FK_SUBVENCION" FOREIGN KEY ("IDPLAN") REFERENCES  "SCCI_PLAN" ("IDPLAN")
   )
/
-- TABLA TRABAJOS
CREATE TABLE  "SCCI_TRABAJOS" 
   (	"IDTRABAJO" NUMBER(10,0) NOT NULL, 
    "IDSUBVENCION" NUMBER(10,0) NOT NULL,
    "IDEMPRESA" NUMBER(10,0) NOT NULL,
    "FECHAASIGNACION" DATE NOT NULL,
    "ESTADO" NUMBER(1,0) NOT NULL,
	 CONSTRAINT "SCCI_TRABAJOS_PK" PRIMARY KEY ("IDTRABAJO"),
     CONSTRAINT "SCCI_EMPRESA_FK_TRABAJOS" FOREIGN KEY ("IDEMPRESA") REFERENCES  "SCCI_EMPRESA" ("IDEMPRESA"),
     CONSTRAINT "SCCI_SUBVENCION_FK_TRABAJOS" FOREIGN KEY ("IDSUBVENCION") REFERENCES  "SCCI_SUBVENCION" ("IDSUBVENCION") 
   )
/

-- PETICIONES
CREATE TABLE  "SCCI_PETICION" 
   (	"IDPETICION" NUMBER(10,0) NOT NULL, 
    "IDPROPIETARIO" NUMBER(10,0) NOT NULL,
    "IDPARCELA" NUMBER(10,0) NOT NULL, 
    "IDSUBVENCION" NUMBER(10,0) NOT NULL, 
    "FECHAPETICION" DATE NOT NULL,
    "RESOLUCION" NUMBER(2) NOT NULL,
    "FECHARESOLUCION" DATE NULL,
    "ANUALIDAD" NUMBER NOT NULL,
	CONSTRAINT "SCCI_PETICION_PK" PRIMARY KEY ("IDPETICION"),
    CONSTRAINT "SCCI_PARCELA_FK_PETICION" FOREIGN KEY ("IDPARCELA") REFERENCES  "SCCI_PARCELA" ("IDPARCELA"),
    CONSTRAINT "SCCI_PROPIETARIO_FK_PETICION" FOREIGN KEY ("IDPROPIETARIO") REFERENCES  "SCCI_PROPIETARIO" ("IDPROPIETARIO"),
    CONSTRAINT "SCCI_SUBVENCION_FK_PETICION" FOREIGN KEY ("IDSUBVENCION") REFERENCES  "SCCI_SUBVENCION" ("IDSUBVENCION") 
   )
/


-- TABLAS DEL MDULO DE GESTIN DE LOS INCENDIOS
CREATE TABLE  "SCCI_RIESGO" 
   (	"IDRIESGO" NUMBER(10,0) NOT NULL, 
	"IDVEGETACION" NUMBER(10,0) NOT NULL, 
	"IDDENSIDAD" NUMBER(10,0) NOT NULL,
    "IDPENDIENTE" NUMBER(10,0) NOT NULL,
    "IDPLUVIOMETRIA" NUMBER(10,0) NOT NULL,
    "IDEROSION" NUMBER(10,0) NOT NULL,
    "VALORRIESGO" NUMBER(5,2) NOT NULL,
    "ACTIVO" NUMBER(1,0) NOT NULL,
	 CONSTRAINT "SCCI_RIESGO_PK" PRIMARY KEY ("IDRIESGO"),
     CONSTRAINT "SCCI_VEGETACION_FK_RIESGO" FOREIGN KEY ("IDVEGETACION") REFERENCES  "SCCI_VEGETACION" ("IDVEGETACION"),
     CONSTRAINT "SCCI_DENSIDAD_FK_RIESGO" FOREIGN KEY ("IDDENSIDAD") REFERENCES  "SCCI_DENSIDAD" ("IDDENSIDAD") ,
     CONSTRAINT "SCCI_PENDIENTE_FK_RIESGO" FOREIGN KEY ("IDPENDIENTE") REFERENCES  "SCCI_PENDIENTE" ("IDPENDIENTE"),
     CONSTRAINT "SCCI_PLUVIOMETRIA_FK_RIESGO" FOREIGN KEY ("IDPLUVIOMETRIA") REFERENCES  "SCCI_PLUVIOMETRIA" ("IDPLUVIOMETRIA"),
     CONSTRAINT "SCCI_EROSION_FK_RIESGO" FOREIGN KEY ("IDEROSION") REFERENCES  "SCCI_EROSION" ("IDEROSION") 
   )
/

CREATE TABLE  "SCCI_INCENDIO" 
   (	"IDINCENDIO" NUMBER(10,0) NOT NULL, 
  "IDPARCELA" NUMBER(10,0) NOT NULL, 
  "FECHA" DATE NOT NULL,
  "DAO" NUMBER(10,2) NOT NULL,
  "ANUALIDAD" NUMBER NOT NULL,
  "ACTIVO" NUMBER(1,0) NOT NULL,
  CONSTRAINT "SCCI_INCENDIO_PK" PRIMARY KEY ("IDINCENDIO"),
  CONSTRAINT "SCCI_PARCELA_FK_INCENDIO" FOREIGN KEY ("IDPARCELA") REFERENCES  "SCCI_PARCELA" ("IDPARCELA")
  
   )
/


-- TABLAS DEL MDULO ESTADISTICO
-- ESTADISTICA NMERO 1
CREATE TABLE  "SCCI_ESTADISTICA1" 
   (	"ANUALIDAD" NUMBER(10,0) NOT NULL,
	"SUPERFICIE"  NUMBER(10,0) NOT NULL
   )
/
-- ESTADISTICA NMERO 2
CREATE TABLE  "SCCI_ESTADISTICA2" 
   (	"ANUALIDAD" NUMBER(10,0) NOT NULL,
   "SUPERFICIEAFECTADACONPLAN" NUMBER(10,0) NOT NULL,
   "TOTALSUPERFICIEAFECTADA" NUMBER(10,0) NOT NULL,
    "PORCINCENDIO" NUMBER(10,0) NOT NULL
   )
/
-- ESTADISTICA NMERO 3
CREATE TABLE  "SCCI_ESTADISTICA3" 
   (	"TOP5VEGETACIONID" NUMBER(10) NOT NULL
   )
/
-- ESTADISTICA NMERO 4
CREATE TABLE  "SCCI_ESTADISTICA4" 
   (	"ANUALIDAD" NUMBER(10,0) NOT NULL,
	"PORCPROPIETARIOS"  NUMBER(10,0) NOT NULL
   )
/
-- ESTADISTICA NMERO 5
CREATE TABLE  "SCCI_ESTADISTICA5" 
   (	"IDVEGETACION" NUMBER(10,0) NOT NULL
   )
/
-- ESTADISTICA NMERO 6
CREATE TABLE  "SCCI_ESTADISTICA6" 
   (	"ANUALIDAD" NUMBER(10,0) NOT NULL
   )
/
-- ESTADISTICA NMERO 7
CREATE TABLE  "SCCI_ESTADISTICA7" 
   (
    "PORCDIFINCENDIO"  NUMBER(10,0) NOT NULL
   )
/
-- ESTADISTICA NMERO 8
CREATE TABLE  "SCCI_ESTADISTICA8" 
   (	"TOP10PARCELAS" NUMBER(10) NOT NULL
   )
/
-- ESTADISTICA NMERO 9
CREATE TABLE  "SCCI_ESTADISTICA9" 
   (	"ANUALIDAD" NUMBER(10) NOT NULL,
	"PORCEXITO" NUMBER(10,2) NOT NULL
   )
/

