--ALTA PROPIETARIO
create or replace PROCEDURE "SP_ALTA_PROPIETARIO"

            (IDPROPIETARIO IN NUMBER,
            NOMBRE IN VARCHAR,
            APELLIDO1 IN VARCHAR,
            APELLIDO2 IN VARCHAR,
            MAIL IN VARCHAR,
            TELEFONO IN VARCHAR,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
           -- INSERTO DATOS EN PROPIETARIOS CON ESTADO = 1 (ALTA), CON LA FECHA DE REGISTRO ACTUAL Y SIN FECHA DE BAJA
            INSERT INTO SCCI_PROPIETARIO VALUES ( IDPROPIETARIO, NOMBRE, APELLIDO1, APELLIDO2, MAIL, TELEFONO, SYSDATE(), NULL, 1);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN
                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PROPIETARIO', 'ALTA_PROPIETARIO: '||IDPROPIETARIO||'', SYSDATE(), RSP);
              
                RETURN;
              
                -- EN CASO DE ERROR              
                EXCEPTION
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
                      -- MODIFICO ENTONCES LA ENTRADA EN EL LOG CON EL ERROR ESPECIFICADO EN RSP
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PROPIETARIO', 'ALTA_PROPIETARIO: '||IDPROPIETARIO||'', SYSDATE(), RSP);
                  
                        RETURN;

END;
END;

/




--ALTA PARCELA
create or replace PROCEDURE "SP_ALTA_PARCELA"

            (IDPARCELA IN NUMBER,
            IDPROPIETARIO IN NUMBER,
            IDRIESGO IN NUMBER,
            ELEVACION IN NUMBER,
            SUPERFICIE IN NUMBER,
            COORDENADAS IN VARCHAR,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            RESPUESTA VARCHAR(500);
      
            
            BEGIN
        

            -- INSERTO DATOS EN PARCELA
            INSERT INTO SCCI_PARCELA VALUES (IDPARCELA, IDPROPIETARIO, IDRIESGO, ELEVACION, SUPERFICIE, COORDENADAS, 1);
                 
            -- ACTUALIZO ESTADISTICA
            
             SP_ESTADISTICA_3(RESPUESTA);
             SP_ESTADISTICA_5(RESPUESTA);
             SP_ESTADISTICA_8(RESPUESTA);
             SP_ESTADISTICA_9(RESPUESTA);             
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PARCELA', 'ALTA_PARCELA: '||IDPARCELA||'', SYSDATE(), RSP);
              
              
                RETURN;
              
                -- EN CASO DE ERROR              
                EXCEPTION
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PARCELA', 'ALTA_PARCELA: '||IDPARCELA||'', SYSDATE(), RSP);
                  
                          RETURN;
                          


     
END;
END;

/



--ALTA VEGETACION
create or replace PROCEDURE "SP_ALTA_VEGETACION"

            (IDVEGETACION IN NUMBER,
            CLASIFICACION IN VARCHAR,
            ESPECIE IN VARCHAR,
            RECUBRIMIENTO IN NUMBER,
            ALTURA IN NUMBER,
            RECUBRIMIENTOSOTO IN NUMBER,
            ALTURASOTO IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ERRORCLASIFICACION EXCEPTION;
            ERRORRECUBRIMIENTO EXCEPTION;
            ERRORRECUBRIMIENTOSOTO EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
        -- LOS CAMPOS DE CLASIFICACION DEL BOSQUE Y LOS RECUBRIMIENTOS ESTN MARCADOS CON INDICADORES QUE SE EXPONEN EN LA MEMORIA.
        -- POR TANTO EN CLASIFICIACION SOLO PUEDE TENER LOS CAMPOS: FE, FC, FS, FD, FX, WE, WS, WD, WX, SE, SS, SD, SX, DE, DS, DD, DX, DT, HT, HM, HS, HF, M, B


        --CONTROL DE ENTRADA

  
        IF ((CLASIFICACION <> 'FE') AND (CLASIFICACION <> 'FC') AND (CLASIFICACION <> 'FS') AND (CLASIFICACION <> 'FD') AND (CLASIFICACION <> 'FX') AND (CLASIFICACION <> 'WE') AND (CLASIFICACION <> 'WS') 
        AND (CLASIFICACION <> 'WD') AND (CLASIFICACION <> 'WX') AND (CLASIFICACION <> 'SE')  AND (CLASIFICACION <> 'SS') AND (CLASIFICACION <> 'SD') AND  (CLASIFICACION <> 'SX') AND (CLASIFICACION <> 'DE')
        AND (CLASIFICACION <> 'DS') AND  (CLASIFICACION <> 'DD') AND (CLASIFICACION <> 'DX') AND (CLASIFICACION <> 'DT') AND (CLASIFICACION <> 'HT') AND (CLASIFICACION <> 'HM') AND (CLASIFICACION <> 'HS')
        AND (CLASIFICACION <> 'HF') AND  (CLASIFICACION <> 'M')  AND  (CLASIFICACION <> 'B'))   THEN RAISE ERRORCLASIFICACION;
        END IF;
 

        -- Y EN EL CASO DE LOS RECUBRIMIENTOS SER UN NMERO DEL 1 AL 7 DONDE 1 ES MAS CERRADO Y 7 EL RECUBRIMIENTO MAS ABIERTO.
        
            IF ((RECUBRIMIENTO < 1) OR (RECUBRIMIENTO > 7)) THEN RAISE ERRORRECUBRIMIENTO;
            END IF;
            
            IF ((RECUBRIMIENTOSOTO < 1) OR (RECUBRIMIENTOSOTO > 7)) THEN RAISE ERRORRECUBRIMIENTOSOTO;
            END IF;

            -- SI HE LLEGADO HASTA AQUI LOS DATOS SON CORRECTOS. INSERTO DATOS EN PARCELA
            INSERT INTO SCCI_VEGETACION VALUES (IDVEGETACION, CLASIFICACION, ESPECIE, RECUBRIMIENTO, ALTURA, RECUBRIMIENTOSOTO, ALTURASOTO, 1);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'ALTA_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                
                WHEN ERRORCLASIFICACION THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DE CLASIFICACION INTRODUCIDOS NO CORRECTOS. DEBE SER UN VALOR: FE, FC, FS, FD, FX, WE, WS, WD, WX, SE, SS, SD, SX, DE, DS, DD, DX, DT, HT, HH, HS, HF, M o B. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'ALTA_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
                        
                        RETURN;
                
                    WHEN ERRORRECUBRIMIENTO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DE RECUBRIMIENTO INTRODUCIDOS NO CORRECTOS. DEBE SER UN NMERO DEL 1 AL 7. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'ALTA_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
                        
                        RETURN;
                        
                
                    WHEN ERRORRECUBRIMIENTOSOTO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DE RECUBRIMIENTO DEL SOTOBOSQUE INTRODUCIDOS NO CORRECTOS. DEBE SER UN NMERO DEL 1 AL 7.CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'ALTA_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
                        
                        RETURN;
                        
                       
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'ALTA_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/




--ALTA DENSIDAD 
create or replace PROCEDURE "SP_ALTA_DENSIDAD"

            (IDDENSIDAD IN NUMBER,
            DISTANCIAMEDIA IN NUMBER,
            DIAMETRORAICES IN VARCHAR,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ERRORDIAMETRORAICES EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
        -- EL CAMPO DE DIAMETRO DE LA RAIZ SOLO PUEDE TENER LOS VALORES VF, F, M y C SEGN LA MEMORIA.
        --CONTROL DE ENTRADA

  
        IF ((DIAMETRORAICES <> 'VF') AND (DIAMETRORAICES <> 'F') AND (DIAMETRORAICES <> 'M') AND (DIAMETRORAICES <> 'C'))   THEN RAISE ERRORDIAMETRORAICES;
        END IF;
 
            -- SI HE LLEGADO HASTA AQUI LOS DATOS SON CORRECTOS. INSERTO DATOS EN PARCELA
            INSERT INTO SCCI_DENSIDAD VALUES (IDDENSIDAD, DISTANCIAMEDIA, DIAMETRORAICES, 1);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'DENSIDAD', 'ALTA_DENSIDAD: '||IDDENSIDAD||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                
                WHEN ERRORDIAMETRORAICES THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DE DIAMETRO DE LAS RAICES INTRODUCIDOS NO CORRECTOS. DEBE SER UN VALOR: VF, F, M o C. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'DENSIDAD', 'ALTA_DENSIDAD: '||IDDENSIDAD||'', SYSDATE(), RSP);
                        
                        RETURN;
                                        
                       
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'DENSIDAD', 'ALTA_DENSIDAD: '||IDDENSIDAD||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/


--ALTA PENDIENTE 
create or replace PROCEDURE "SP_ALTA_PENDIENTE"

            (IDPENDIENTE IN NUMBER,
            TIPO IN VARCHAR,
            GRADIENTE IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ERRORTIPO EXCEPTION;
            ERRORGRADIENTE EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
        -- EL CAMPO TIPO SOLO PUEDE TENER LOS VALORES S,C,V,T y X SEGN LA MEMORIA.
        -- EL CAMPO GRADIENTE HA DE SER UN VALOR ENTRE 1 Y 10.
        
        --CONTROL DE ENTRADA

  
        IF ((TIPO <> 'S') AND (TIPO <> 'C') AND (TIPO <> 'V') AND (TIPO <> 'T') AND (TIPO <> 'X'))   THEN RAISE ERRORTIPO;
        END IF;
 
 
        IF ((GRADIENTE < 1) OR (GRADIENTE > 10)) THEN RAISE ERRORGRADIENTE;
            END IF;
            
            -- SI HE LLEGADO HASTA AQUI LOS DATOS SON CORRECTOS. INSERTO DATOS EN PARCELA
            INSERT INTO SCCI_PENDIENTE VALUES (IDPENDIENTE, TIPO, GRADIENTE, 1);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PENDIENTE', 'ALTA_PENDIENTE: '||IDPENDIENTE||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                
                WHEN ERRORTIPO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DEL GRADIENTE INTRODUCIDOS NO CORRECTOS. DEBE SER UN VALOR: S, C, V, T o X. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PENDIENTE', 'ALTA_PENDIENTE: '||IDPENDIENTE||'', SYSDATE(), RSP);
                        
                        RETURN;
    
               WHEN ERRORGRADIENTE THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DEL TIPO INTRODUCIDOS NO CORRECTOS. DEBE SER UN NMERO DEL 1 AL 10. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PENDIENTE', 'ALTA_PENDIENTE: '||IDPENDIENTE||'', SYSDATE(), RSP);
                        
                        RETURN;
                                        
                           
                       
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PENDIENTE', 'ALTA_PENDIENTE: '||IDPENDIENTE||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/



--ALTA PLUVIOMETRIA 
create or replace PROCEDURE "SP_ALTA_PLUVIOMETRIA"

            (IDPLUVIOMETRIA IN NUMBER,
            CONDICIONACTUAL IN VARCHAR,
            CONDICIONPASADA IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ERRORACTUAL EXCEPTION;
            ERRORPASADA EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
        -- EL CAMPO CONDICIONACTUAL SOLO PUEDE TENER LOS VALORES SU, PC, OV, RA, SL y SN SEGN LA MEMORIA.
        -- EL CAMPO CONDICIONPASADA HA DE SER UN VALOR ENTRE 1 Y 6.
        
        --CONTROL DE ENTRADA

  
        IF ((CONDICIONACTUAL <> 'SU') AND (CONDICIONACTUAL <> 'PC') AND (CONDICIONACTUAL <> 'OV') AND (CONDICIONACTUAL <> 'RA') AND (CONDICIONACTUAL <> 'SL') AND (CONDICIONACTUAL <> 'SN'))   THEN RAISE ERRORACTUAL;
        END IF;
 
 
        IF ((CONDICIONPASADA < 1) OR (CONDICIONPASADA > 6)) THEN RAISE ERRORPASADA;
            END IF;
            
            -- SI HE LLEGADO HASTA AQUI LOS DATOS SON CORRECTOS. INSERTO DATOS EN PARCELA
            INSERT INTO SCCI_PLUVIOMETRIA VALUES (IDPLUVIOMETRIA, CONDICIONACTUAL, CONDICIONPASADA, 1);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLUVIOMETRIA', 'ALTA_PLUVIOMETRIA: '||IDPLUVIOMETRIA||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                
                WHEN ERRORACTUAL THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DE LAS CONDICIONES ACTUALES NO SON CORRECTOS. DEBE SER UN VALOR: SU, PC, OV,RA, SL O SN. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLUVIOMETRIA', 'ALTA_PLUVIOMETRIA: '||IDPLUVIOMETRIA||'', SYSDATE(), RSP);
                        
                        RETURN;
    
               WHEN ERRORPASADA THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DE LAS CONDICIONES PASADAS NO SON CORRECTOS. DEBE SER UN NMERO DEL 1 AL 6. CONSULTE LOS DATOS VALIDOS';

                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLUVIOMETRIA', 'ALTA_PLUVIOMETRIA: '||IDPLUVIOMETRIA||'', SYSDATE(), RSP);
                        
                        RETURN;
                                        
                           
                       
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLUVIOMETRIA', 'ALTA_PLUVIOMETRIA: '||IDPLUVIOMETRIA||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/






--ALTA EROSION 
create or replace PROCEDURE "SP_ALTA_EROSION"

            (IDEROSION IN NUMBER,
            AFECTACION IN NUMBER,
            GRADO IN VARCHAR,
            PERIODO IN VARCHAR,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ERRORAFECTACION EXCEPTION;
            ERRORGRADO EXCEPTION;
            ERRORPERIODO EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
        -- EL CAMPO AFECTACION SOLO PUEDE TENER VALORES ENTRE 0 Y 5
        -- EL CAMPO GRADO SOLO PUEDE TENER LOS VALORES S, M, V y E SEGN LA MEMORIA.
        -- EL CAMPO PERIODO SOLO PUEDE TENER LOS VALORES A, R, M, N y X SEGN LA MEMORIA.
        
        --CONTROL DE ENTRADA

  
        IF ((GRADO <> 'S') AND (GRADO <> 'M') AND (GRADO <> 'V') AND (GRADO <> 'E'))   THEN RAISE ERRORGRADO;
        END IF;
 
        IF ((PERIODO <> 'A') AND (PERIODO <> 'R') AND (PERIODO <> 'M') AND (PERIODO <> 'N') AND (PERIODO <> 'X'))   THEN RAISE ERRORPERIODO;
        END IF;
  
        IF ((AFECTACION < 0) OR (AFECTACION > 5)) THEN RAISE ERRORAFECTACION;
        END IF;
            
            -- SI HE LLEGADO HASTA AQUI LOS DATOS SON CORRECTOS. INSERTO DATOS EN PARCELA
            INSERT INTO SCCI_EROSION VALUES (IDEROSION, AFECTACION, GRADO, PERIODO, 1);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'ALTA_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION

                WHEN ERRORAFECTACION THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DE LA AFECTACION ACTUALES NO SON CORRECTOS. DEBE SER UN NUMERO DEL 1 AL 5. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'ALTA_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
                        
                        RETURN;
    
               WHEN ERRORGRADO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS LOS GRADOS DEBEN ESTAR ENTRE: S, M, V y E. LOS INTRODUCIDOS NO SON CORRECTOS. CONSULTE LOS DATOS VALIDOS';

                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'ALTA_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
                        
                        RETURN;

              WHEN ERRORPERIODO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS LOS PERIODOS DEBEN ESTAR ENTRE: A, R, M, N y X. LOS INTRODUCIDOS NO SON CORRECTOS. CONSULTE LOS DATOS VALIDOS';

                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'ALTA_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
                        
                        RETURN;             
                           
                       
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'ALTA_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/




--ALTA RIESGO 
create or replace PROCEDURE "SP_ALTA_RIESGO"

            (IDRIESGO IN NUMBER,
            IDVEGETACION IN NUMBER,
            IDDENSIDAD IN NUMBER,
            IDPENDIENTE IN NUMBER,
            IDPLUVIOMETRIA IN NUMBER,
            IDEROSION IN NUMBER,
            VALORRIESGO IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
             
            -- TODOS LOS CONTROLES SE HACEN POR RELACIONES O POR EL TIPO DE CAMPO. NO HACE FALTA UN CONTROL ADICIONAL.
            
            INSERT INTO SCCI_RIESGO VALUES (IDRIESGO, IDVEGETACION, IDDENSIDAD, IDPENDIENTE, IDPLUVIOMETRIA, IDEROSION, VALORRIESGO, 1);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'RIESGO', 'ALTA_RIESGO: '||IDRIESGO||'', SYSDATE(), RSP);
              
              
                RETURN;
                      
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                                      
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'RIESGO', 'ALTA_RIESGO: '||IDRIESGO||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/


--ALTA INCENDIO 
create or replace PROCEDURE "SP_ALTA_INCENDIO"

            (IDINCENDIO IN NUMBER,
            IDPARCELA IN NUMBER,
            FECHA IN DATE,
            DAO IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            
            DECLARE 
            ERRORESTADISTICA1 EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            ANUALIDADLOCAL NUMBER;
            IDPARCELALOCAL NUMBER(10,0);
            RESPUESTA VARCHAR(1000);
            
            
            BEGIN
        
   
        
            -- ACTUALIZO LA ESTADISTICA 1 EN UNA VARIABLE LOCAL
            ANUALIDADLOCAL:= EXTRACT (YEAR FROM FECHA);
            
     
            -- COPIO LA PARCELA EN UNA VARIABLE LOCAL
            IDPARCELALOCAL := IDPARCELA;
        
      

              
            -- TODOS LOS CONTROLES SE HACEN POR RELACIONES O POR EL TIPO DE CAMPO. NO HACE FALTA UN CONTROL ADICIONAL.
            --ASIGNO AUTOMATICAMENTE LA ANUALIDAD EN FUNCION DE LA FECHA ASIGNADA
            
            INSERT INTO SCCI_INCENDIO VALUES (IDINCENDIO, IDPARCELA, FECHA, DAO, ANUALIDADLOCAL,  1);
            
            
            -- LLAMO AL PROCEDIMIENTO CON LAS VARIABLES LOCALES PARA ACTUALIZAR LA ESTADISTICA
            -- EN BASE A LOS DATOS PASADOS COMO PARAMETRO
              
              SP_ESTADISTICA_1(ANUALIDADLOCAL, IDPARCELALOCAL, RESPUESTA);
              SP_ESTADISTICA_3(RESPUESTA);
              SP_ESTADISTICA_5(RESPUESTA);
              SP_ESTADISTICA_7(RESPUESTA);
              
              
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN
  
     
    
     
                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'INCENDIO', 'ALTA_INCENDIO: '||IDINCENDIO||'', SYSDATE(), RSP);
                      
              
                RETURN;
                      
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                
                 WHEN ERRORESTADISTICA1 THEN
                 
                 RSP:= 'HA OCURRIDO UN ERROR CON LA ESTADISTICA. SE TIENE QUE ABORTAR LA OPERACIN';
                  -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'ESTADISTICA1', 'ALTA_INCENDIO: '||IDINCENDIO||'', SYSDATE(), RSP);
                  
                        RETURN;
                                      
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'INCENDIO', 'ALTA_INCENDIO: '||IDINCENDIO||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;


/





--ALTA EMPRESA 
create or replace PROCEDURE "SP_ALTA_EMPRESA"

            (IDEMPRESA IN NUMBER,
            NOMBRE IN VARCHAR,
            CIF IN VARCHAR,
            DIRECCION IN VARCHAR,
            TELEFONO IN VARCHAR,
            HOMOLOGADA IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
            INSERT INTO SCCI_EMPRESA VALUES (IDEMPRESA, NOMBRE, CIF, DIRECCION, TELEFONO, HOMOLOGADA, 1);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EMPRESA', 'ALTA_EMPRESA: '||IDEMPRESA||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EMPRESA', 'ALTA_EMPRESA: '||IDEMPRESA||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/


--ALTA PLAN
create or replace PROCEDURE "SP_ALTA_PLAN"

            (IDPLAN IN NUMBER,
            NOMBRE IN VARCHAR,
            ANUALIDAD IN VARCHAR,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN

            -- INSERTO DATOS EN PLAN
            INSERT INTO SCCI_PLAN VALUES (IDPLAN, NOMBRE, ANUALIDAD, NULL, 1);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLAN', 'ALTA_PLAN: '||IDPLAN||'', SYSDATE(), RSP);
              
              
                RETURN;
              
                -- EN CASO DE ERROR              
                EXCEPTION
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLAN', 'ALTA_PLAN: '||IDPLAN||'', SYSDATE(), RSP);
                  
                          RETURN;
                          


     
END;
END;

/


--ALTA SUBVENCION 
create or replace PROCEDURE "SP_ALTA_SUBVENCION"

            (VIDSUBVENCION IN NUMBER,
            VIDPLAN IN NUMBER,
            VFECHAINICIO IN DATE,
            VFECHAFINAL IN DATE,
            VESTADO IN NUMBER, 
            VIMPORTEMAX IN NUMBER,
            VGASTOACTUAL IN NUMBER, 
            RSP OUT VARCHAR
            )
            
            IS
            BEGIN
            DECLARE
            ERRORESTADO EXCEPTION;
            ERRORGASTO EXCEPTION;
            ERRORANUALIDAD EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            PROPIETARIOPARCELA NUMBER(10,0);
            ANUALIDADACTUAL VARCHAR(20);
            ANUALIDADPLAN VARCHAR(20);
            PETICIONGANADORADEFECTO NUMBER(10,0);
            ESTADODEFECTO NUMBER(1);
            GASTOACTUALDEFECTO NUMBER (10,2);
            HAYDATOS NUMBER(10,0):=NULL;
            VANUALIDAD NUMBER;
                    
          
            BEGIN
            --CONDICIONES INICIALES DE LAS SUBVENCIONES CUANDO SE DAN DE ALTA
            PETICIONGANADORADEFECTO := NULL; --POR DEFECTO NO TIENE NINGUNA YA QUE SE ACABA DE CREAR LA SUBVENCION Y TODAVIA NO TIENE PETICIONES
            ESTADODEFECTO :=1; --POR DEFECTO EN UN ALTA SU ESTADO PASA SIEMPRE A SER EN CURSO
            GASTOACTUALDEFECTO :=0; --POR DEFECTO EN UN ALTA EL GASTO INICIAL SIEMPRE ES 0. NO SE PUEDE DAR DE ALTA CON GASTO YA HECHO
            
            -- OBTENGO EL AO ACTUAL EN CURSO
            SELECT EXTRACT(YEAR FROM sysdate) INTO ANUALIDADACTUAL FROM dual;
            
            -- OBTENGO LA ANUALIDAD DE LA SUBVENCION
            
            VANUALIDAD:= EXTRACT (YEAR FROM VFECHAINICIO);
            
            -- BUSCO LA ANUALIDAD A LA QUE PERTENECE EL PLAN INTRODUCIDO
            SELECT COUNT(*) INTO HAYDATOS FROM SCCI_PLAN WHERE IDPLAN = VIDPLAN AND ACTIVO = 1;
            
            IF (HAYDATOS  <> 0) THEN
                 SELECT ANUALIDAD INTO ANUALIDADPLAN FROM SCCI_PLAN WHERE IDPLAN = VIDPLAN AND ACTIVO = 1;
                HAYDATOS := NULL;
            END IF;
        
        
        -- COMPRUEBO QUE EL PLAN PARA EL QUE CREO LA SUBVENCION SEA DE ESTE AO
                IF (ANUALIDADACTUAL <> ANUALIDADPLAN) THEN RAISE ERRORANUALIDAD;
                END IF;



        -- COMPRUEBO QUE NO SE HAYA PUESTO NADA EXTRAO EN ESTADO
        -- LOS VALORES SERIAN:
        --    ESTADO =1 : EN PROCESO DE ADJUDICACION
        --    ESTADO =2 : ADJUDICADA
        --    ESTADO =3 : FINALIZADA
            
          IF ((VESTADO < 0) OR (VESTADO > 4)) THEN RAISE ERRORESTADO;
           END IF;
            
     
                
        --POR OTRO LADO NO DEBO DEJAR INTRODUCIR GASTO EN AQUELLAS SITUACIONES EN LAS QUE LA SUBVENCION NO ESTA ADJUDICADA.
        --ES DECIR SOLO SE PUEDE INTRODUCIR GASTO SI EL ESTADO ES 2

        IF ((VGASTOACTUAL <> 0) AND (VESTADO <> 2)) THEN RAISE ERRORGASTO;
        END IF;
        
        INSERT INTO SCCI_SUBVENCION VALUES (VIDSUBVENCION, VIDPLAN, PETICIONGANADORADEFECTO, VFECHAINICIO, VFECHAFINAL, ESTADODEFECTO, VIMPORTEMAX, GASTOACTUALDEFECTO, VANUALIDAD);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'ALTA_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                

                WHEN ERRORESTADO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DEL ESTADO NO SON CORRECTOS. DEBE SER UN NUMERO DEL 1 AL 3. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'ALTA_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                        
                        RETURN;
                  
                  
                  
                  WHEN ERRORGASTO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: EL ESTADO ACTUAL DE LA SUBVENCION NO PERMITE INTRODUCIR GASTOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'ALTA_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                        
                        RETURN;
           
                    WHEN ERRORANUALIDAD THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: EL PLAN SELECCIONADO NO ES PARA EL AO' || ANUALIDADACTUAL;
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'ALTA_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                        
                        RETURN;
    
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'ALTA_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
                          
END;

/




--ALTA TRABAJOS 
create or replace PROCEDURE "SP_ALTA_TRABAJOS"

            (VIDTRABAJO IN NUMBER,
            VIDSUBVENCION IN NUMBER,
            VIDEMPRESA IN NUMBER,

            VFECHAASIGNACION IN DATE,
            VESTADO IN NUMBER:=1,  --POR DEFECTO DEBERIA SER 1 SI ES UN ALTA EL ESTADO DE LA ASIGNACION ES 1 YA QUE ES UN TRABAJO QUE COMIENZA Y ESTAR EN CURSO.
            RSP OUT VARCHAR
            )
            
            IS
            BEGIN
            DECLARE
            ERRRORHOMOLOGADA EXCEPTION;
            ERRORESTADOSUBVENCION EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            ESTADOHOMOLOGACION NUMBER(1);
            ESTADOSUBVENCION NUMBER(1);
            HAYDATOS NUMBER(10,0):=NULL;
            
                    
          
            BEGIN
    
            
        -- HE DE COMPROBAR QUE LA EMPRESA EST HOMOLOGADA. SINO NO LE PUEDO ASIGNAR TRABAJOS
        
        --EVITA ERROR DE QUE NO HAYA DATOS Y SALTE LA EXCEPCION
        
        SELECT COUNT(*) INTO HAYDATOS FROM SCCI_EMPRESA WHERE IDEMPRESA = VIDEMPRESA AND ACTIVO = 1;
        
        IF (HAYDATOS <> 0) THEN
             SELECT HOMOLOGADA INTO ESTADOHOMOLOGACION FROM SCCI_EMPRESA WHERE IDEMPRESA = VIDEMPRESA AND ACTIVO = 1;
             HAYDATOS := NULL;
        END IF;
        
        
        -- SI LA EMPRESA NO ESTA HOMOLOGADA NO SE PUEDE ASIGNAR LA SUBVENCION
        IF (ESTADOHOMOLOGACION <> 1) THEN RAISE ERRRORHOMOLOGADA;
        END IF;

        -- HE DE COMPROBAR QUE LA SUBVENCION EST ACEPTADA. SINO NO LE PUEDO ASIGNAR UNA EMPRESA
             SELECT COUNT(*) INTO HAYDATOS FROM SCCI_SUBVENCION WHERE IDSUBVENCION = VIDSUBVENCION;
        
        IF (HAYDATOS <> 0) THEN
             SELECT ESTADO INTO ESTADOSUBVENCION FROM SCCI_SUBVENCION WHERE IDSUBVENCION = VIDSUBVENCION;
            HAYDATOS := NULL;
        END IF;
        
        -- SI LA SUBVENCION NO ESTA ADJUDICADA = 2. NO SE PUEDE ASIGNAR LA SUBVENCION
        IF (ESTADOSUBVENCION <> 2) THEN RAISE ERRORESTADOSUBVENCION;
        END IF;
                
        --SINO LE ASIGNO LA SUBVENCION A LA EMPRESA QUE TRABAJARA
        INSERT INTO SCCI_TRABAJOS VALUES (VIDTRABAJO, VIDSUBVENCION, VIDEMPRESA, VFECHAASIGNACION, VESTADO);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'TRABAJOS', 'ALTA_TRABAJOS: '||VIDTRABAJO||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                

                WHEN ERRRORHOMOLOGADA THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LA EMPRESA TIENE QUE ESTAR HOMOLOGADA PARA ASIGNARLE UN TRABAJO';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'TRABAJOS', 'ALTA_TRABAJOS: '||VIDTRABAJO||'', SYSDATE(), RSP);
                        
                        RETURN;
                  
                  
                  
                  WHEN ERRORESTADOSUBVENCION THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: EL ESTADO ACTUAL DE LA SUBVENCION NO PERMITE SU ASIGNACION. TIENE QUE ESTAR ADJUDICADA Y NO FINALIZADA.';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'TRABAJOS', 'ALTA_TRABAJOS: '||VIDTRABAJO||'', SYSDATE(), RSP);
                        
                        RETURN;
    
    
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'TRABAJOS', 'ALTA_TRABAJOS: '||VIDTRABAJO||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
                          
END;

/



--ALTA PETICION 
create or replace PROCEDURE "SP_ALTA_PETICION"
        (VIDPETICION IN NUMBER,
            VIDPROPIETARIO IN NUMBER,
            VIDPARCELA IN NUMBER,
            VIDSUBVENCION IN NUMBER,
            VFECHAPETICION IN DATE,
            ANUALIDAD IN NUMBER,
            RSP OUT VARCHAR
            )
            
            IS
            BEGIN
            DECLARE
            ERRORPROPIETARIO EXCEPTION;
            ERRORDUPLICADO EXCEPTION;
            ERRORESTADO EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            PROPIETARIOPARCELA NUMBER(10,0);
            PETICIONDUPLICADA NUMBER(10,0);
            HAYDATOS NUMBER(10,0);
            RESOLUCIONDEFECTO NUMBER(1);
            FECHARESOLUCIONDEFECTO DATE;
         
            
            
            BEGIN
            
            
        --INTRODUZCO VALORES POR DEFECTO
        
            RESOLUCIONDEFECTO :=1; -- POR DEFECTO DEBERIA SER 1 YA QUE EN UN ALTA COMIENZA EN EL ESTADO 1. EN CURSO O SOLICITADA.
            FECHARESOLUCIONDEFECTO :=NULL; --POR DEFECTO DEBERIA SER NULL YA EN UNA ALTA TODAVIA NO SE HA PROPUESTO LA RESOLUCION
            PETICIONDUPLICADA := NULL;
            HAYDATOS := NULL;
            
        -- COMPRUEBO QUE NO SE HAYA PUESTO NADA EXTRAO EN ESTADO
        -- LOS VALORES SERIAN:
        --    ESTADO =1 : SOLICITADA Y POR TANTO EN CURSO DE ADJUDICACION
        --    ESTADO =2 : ADJUDICADA O ACEPTADA
        --    ESTADO =3 : RECHAZADA O FINALIZADA
        --    COMO ES UN ALTA SIEMPRE SERA ESTADO = 1 (SOLICITADA)

   
        --HE DE COMPROBAR QUE LA PARCELA INTRODUCIDA CORRESPONDE AL PROPIETARIO INTRODUCIDO.
        --DE OTRA MANERA SE PODRIA ASIGNAR UNA SUBVENCION A UN PROPIETARIO PARA UNA PARCELA QUE NO FUERA SUYA
     
             
              SELECT COUNT(*) INTO HAYDATOS FROM SCCI_PARCELA WHERE (IDPARCELA = VIDPARCELA) AND ACTIVO = 1;
             
        IF (HAYDATOS <> 0) THEN
           
            SELECT IDPROPIETARIO INTO PROPIETARIOPARCELA FROM SCCI_PARCELA WHERE (IDPARCELA = VIDPARCELA) AND ACTIVO = 1;
         HAYDATOS := NULL;
         END IF;

        -- SINO CONCUERDA EL PROPIETARIO DE LA PARCELA CON EL INTRODUCIDO SALTA ERROR. 
        -- NO SE PUEDE GENERAR UNA PETICION SI UN PROPIETARIO NO ES EL VERDADERO PROPIETARIO DE LA PARCELA 

        IF (PROPIETARIOPARCELA <> VIDPROPIETARIO) THEN RAISE ERRORPROPIETARIO;
        END IF;
         
        --COMPRUEBO QUE EL PROPIETARIO PARA ESA PARCELA NO TIENE YA UNA PETICION PENDIENTE
        
        SELECT COUNT(*) INTO HAYDATOS FROM SCCI_PETICION WHERE ((IDPROPIETARIO = VIDPROPIETARIO) AND (IDPARCELA=VIDPARCELA) AND (IDSUBVENCION = VIDSUBVENCION));
        
         IF (HAYDATOS <> 0) THEN RAISE ERRORDUPLICADO;
         END IF;
         
         --CREO LA ANUALIDAD
      
        INSERT INTO SCCI_PETICION VALUES (VIDPETICION, VIDPROPIETARIO, VIDPARCELA, VIDSUBVENCION, VFECHAPETICION, RESOLUCIONDEFECTO, FECHARESOLUCIONDEFECTO, ANUALIDAD);
     
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO SALTA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'ALTA_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                

                WHEN ERRORESTADO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DEL ESTADO NO SON CORRECTOS. DEBE SER UN NUMERO DEL 1 AL 3. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'ALTA_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
                        
                        RETURN;
                  
                  
                  
                WHEN ERRORDUPLICADO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: UN PROPIETARIO NO PUEDE SOLICITAR PARA UNA MISMA PARCELA LA MISMA SUBVENCION DOS VECES';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'ALTA_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
                        
                        RETURN;
                  
                  
                  
                  WHEN ERRORPROPIETARIO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DE LA PARCELA NO SE CORRESPONDEN CON EL PROPIETARIO DE LA MISMA INTRODUCIDO. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                       INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'ALTA_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
                        
                        RETURN;
    
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'ALTA_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
     
                        RETURN;
                          
END;
                          
END;

/


