--MOD PROPIETARIO
create or replace PROCEDURE "SP_MOD_PROPIETARIO"
-- MODIFICA LOS DATOS DE LOS PROPIETARIOS. NO LOS CREA NI LOS DA DE BAJA
-- NO PUEDE MODIFICAR EL CAMPO PROPIETARIO. SOLO LOS DATOS DE ESTE.
            (IDPROPIETARIO IN NUMBER,
            NOMBRE IN VARCHAR,
            APELLIDO1 IN VARCHAR,
            APELLIDO2 IN VARCHAR,
            MAIL IN VARCHAR,
            TELEFONO IN VARCHAR,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        

            -- ACTUALIZO DATOS EN PROPIETARIOS
                    
                UPDATE SCCI_PROPIETARIO SET
                NOMBRE = NOMBRE,
                APELLIDO1 = APELLIDO1,
                APELLIDO2 = APELLIDO2,
                MAIL = MAIL,
                TELEFONO = TELEFONO
                WHERE (IDPROPIETARIO = IDPROPIETARIO);


            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PROPIETARIO', 'MOD_PROPIETARIO: '||IDPROPIETARIO||'', SYSDATE(), RSP);
              
              
                RETURN;
              
                -- EN CASO DE ERROR              
                EXCEPTION
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                         INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PROPIETARIO', 'MOD_PROPIETARIO: '||IDPROPIETARIO||'', SYSDATE(), RSP);
                  
                          RETURN;
                          


     
END;
END;

/




--MOD PARCELA
create or replace PROCEDURE "SP_MOD_PARCELA"

            (IDPARCELA IN NUMBER,
            IDPROPIETARIO IN NUMBER,
            IDRIESGO IN NUMBER,
            ELEVACION IN NUMBER,
            SUPERFICIE IN NUMBER,
            COORDENADAS IN VARCHAR,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            RESPUESTA VARCHAR(500);
            
            BEGIN
        
   
            -- ACTUALIZO DATOS EN PARCELA. EN EL CASO DE NO EXISTIR EL PROPIETARIO O EL RIESGO DAR UN ERROR DE FK
                    
                UPDATE SCCI_PARCELA SET
                IDPROPIETARIO = IDPROPIETARIO,
                IDRIESGO = IDRIESGO,
                ELEVACION = ELEVACION,
                SUPERFICIE = SUPERFICIE,
                COORDENADAS = COORDENADAS
                WHERE (IDPARCELA = IDPARCELA);
                
            
            --ACTUALIZO ESTADISTICAS POR SI CAMBIA EL RIESGO
     
              SP_ESTADISTICA_3(RESPUESTA);
              SP_ESTADISTICA_5(RESPUESTA);
              SP_ESTADISTICA_8(RESPUESTA);
              SP_ESTADISTICA_9(RESPUESTA);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PARCELA', 'MOD_PARCELA: '||IDPARCELA||'', SYSDATE(), RSP);
              
              
                RETURN;
              
                -- EN CASO DE ERROR         
                EXCEPTION
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PARCELA', 'MOD_PARCELA: '||IDPARCELA||'', SYSDATE(), RSP);
                  
                          RETURN;
                          


     
END;
END;

/



--MOD VEGETACION
create or replace PROCEDURE "SP_MOD_VEGETACION"

            (IDVEGETACION IN NUMBER,
            CLASIFICACION IN VARCHAR,
            ESPECIE IN VARCHAR,
            RECUBRIMIENTO IN NUMBER,
            ALTURA IN NUMBER,
            RECUBRIMIENTOSOTO IN NUMBER,
            ALTURASOTO IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ERRORCLASIFICACION EXCEPTION;
            ERRORRECUBRIMIENTO EXCEPTION;
            ERRORRECUBRIMIENTOSOTO EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        -- LOS CONTROLES DE ENTRADA DE DATOS SON LOS MISMOS QUE EN EL CASO DE LAS ALTAS.
        -- LOS CAMPOS DE CLASIFICACION DEL BOSQUE Y LOS RECUBRIMIENTOS ESTN MARCADOS CON INDICADORES QUE SE EXPONEN EN LA MEMORIA.
        -- POR TANTO EN CLASIFICIACION SOLO PUEDE TENER LOS CAMPOS: FE, FC, FS, FD, FX, WE, WS, WD, WX, SE, SS, SD, SX, DE, DS, DD, DX, DT, HT, HM, HS, HF, M, B


        --CONTROL DE ENTRADA

  
        IF ((CLASIFICACION <> 'FE') AND (CLASIFICACION <> 'FC') AND (CLASIFICACION <> 'FS') AND (CLASIFICACION <> 'FD') AND (CLASIFICACION <> 'FX') AND (CLASIFICACION <> 'WE') AND (CLASIFICACION <> 'WS') 
        AND (CLASIFICACION <> 'WD') AND (CLASIFICACION <> 'WX') AND (CLASIFICACION <> 'SE')  AND (CLASIFICACION <> 'SS') AND (CLASIFICACION <> 'SD') AND  (CLASIFICACION <> 'SX') AND (CLASIFICACION <> 'DE')
        AND (CLASIFICACION <> 'DS') AND  (CLASIFICACION <> 'DD') AND (CLASIFICACION <> 'DX') AND (CLASIFICACION <> 'DT') AND (CLASIFICACION <> 'HT') AND (CLASIFICACION <> 'HM') AND (CLASIFICACION <> 'HS')
        AND (CLASIFICACION <> 'HF') AND  (CLASIFICACION <> 'M')  AND  (CLASIFICACION <> 'B'))   THEN RAISE ERRORCLASIFICACION;
        END IF;
 

        -- Y EN EL CASO DE LOS RECUBRIMIENTOS SER UN NMERO DEL 1 AL 7 DONDE 1 ES MAS CERRADO Y 7 EL RECUBRIMIENTO MAS ABIERTO.
        
            IF ((RECUBRIMIENTO < 1) OR (RECUBRIMIENTO > 7)) THEN RAISE ERRORRECUBRIMIENTO;
            END IF;
            
            IF ((RECUBRIMIENTOSOTO < 1) OR (RECUBRIMIENTOSOTO > 7)) THEN RAISE ERRORRECUBRIMIENTOSOTO;
            END IF;

            -- SI HE LLEGADO HASTA AQUI LOS DATOS SON CORRECTOS. INSERTO DATOS EN PARCELA


            -- ACTUALIZO DATOS EN VEGETACION
            
                UPDATE SCCI_VEGETACION SET
                CLASIFICACION = CLASIFICACION,
                RECUBRIMIENTO = RECUBRIMIENTO,
                ALTURA = ALTURA,
                RECUBRIMIENTOSOTO = RECUBRIMIENTOSOTO,
                ALTURASOTO = ALTURASOTO
                WHERE (IDVEGETACION = IDVEGETACION);
                
               
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'MOD_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                
                WHEN ERRORCLASIFICACION THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DE CLASIFICACION INTRODUCIDOS NO CORRECTOS. DEBE SER UN VALOR: FE, FC, FS, FD, FX, WE, WS, WD, WX, SE, SS, SD, SX, DE, DS, DD, DX, DT, HT, HH, HS, HF, M o B. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'MOD_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
                        
                        RETURN;
                
                    WHEN ERRORRECUBRIMIENTO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DE RECUBRIMIENTO INTRODUCIDOS NO CORRECTOS. DEBE SER UN NMERO DEL 1 AL 7. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'MOD_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
                        
                        RETURN;
                        
                
                    WHEN ERRORRECUBRIMIENTOSOTO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DE RECUBRIMIENTO DEL SOTOBOSQUE INTRODUCIDOS NO CORRECTOS. DEBE SER UN NMERO DEL 1 AL 7.CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'MOD_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
                        
                        RETURN;
                        
                       
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'VEGETACION', 'MOD_VEGETACION: '||IDVEGETACION||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/




--MOD DENSIDAD 
create or replace PROCEDURE "SP_MOD_DENSIDAD"

            (IDDENSIDAD IN NUMBER,
            DISTANCIAMEDIA IN NUMBER,
            DIAMETRORAICES IN VARCHAR,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ERRORDIAMETRORAICES EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
        -- EL CAMPO DE DIAMETRO DE LA RAIZ SOLO PUEDE TENER LOS VALORES VF, F, M y C SEGN LA MEMORIA.
        -- LOS CONTROLES DE ENTRADA SON LOS MISMOS QUE EN EL ALTA

  
        IF ((DIAMETRORAICES <> 'VF') AND (DIAMETRORAICES <> 'F') AND (DIAMETRORAICES <> 'M') AND (DIAMETRORAICES <> 'C'))   THEN RAISE ERRORDIAMETRORAICES;
        END IF;
 
            -- SI HE LLEGADO HASTA AQUI LOS DATOS SON CORRECTOS. INSERTO DATOS EN PARCELA

         UPDATE SCCI_DENSIDAD SET
                DISTANCIAMEDIA = DISTANCIAMEDIA,
                DIAMETRORAICES = DIAMETRORAICES
                WHERE (IDDENSIDAD = IDDENSIDAD);
                
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'DENSIDAD', 'MOD_DENSIDAD: '||IDDENSIDAD||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                
                WHEN ERRORDIAMETRORAICES THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DE DIAMETRO DE LAS RAICES INTRODUCIDOS NO CORRECTOS. DEBE SER UN VALOR: VF, F, M o C. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'DENSIDAD', 'MOD_DENSIDAD: '||IDDENSIDAD||'', SYSDATE(), RSP);
                        
                        RETURN;
                                        
                       
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'DENSIDAD', 'MOD_DENSIDAD: '||IDDENSIDAD||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/


--MOD PENDIENTE 
create or replace PROCEDURE "SP_MOD_PENDIENTE"

            (IDPENDIENTE IN NUMBER,
            TIPO IN VARCHAR,
            GRADIENTE IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ERRORTIPO EXCEPTION;
            ERRORGRADIENTE EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
        -- EL CAMPO TIPO SOLO PUEDE TENER LOS VALORES S,C,V,T y X SEGN LA MEMORIA.
        -- EL CAMPO GRADIENTE HA DE SER UN VALOR ENTRE 1 Y 10.
        
        -- CONTROL DE ENTRADA

  
        IF ((TIPO <> 'S') AND (TIPO <> 'C') AND (TIPO <> 'V') AND (TIPO <> 'T') AND (TIPO <> 'X'))   THEN RAISE ERRORTIPO;
        END IF;
 
 
        IF ((GRADIENTE < 1) OR (GRADIENTE > 10)) THEN RAISE ERRORGRADIENTE;
            END IF;
            
            -- SI HE LLEGADO HASTA AQUI LOS DATOS SON CORRECTOS. ACTUALIZO DATOS EN LA PENDIENTE
            
                UPDATE SCCI_PENDIENTE SET
                TIPO = TIPO,
                GRADIENTE = GRADIENTE
                WHERE (IDPENDIENTE = IDPENDIENTE);
                
                
                        
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PENDIENTE', 'MOD_PENDIENTE: '||IDPENDIENTE||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                
                WHEN ERRORTIPO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DEL GRADIENTE INTRODUCIDOS NO CORRECTOS. DEBE SER UN VALOR: S, C, V, T o X. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PENDIENTE', 'MOD_PENDIENTE: '||IDPENDIENTE||'', SYSDATE(), RSP);
                        
                        RETURN;
    
               WHEN ERRORGRADIENTE THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: DATOS DEL TIPO INTRODUCIDOS NO CORRECTOS. DEBE SER UN NMERO DEL 1 AL 10. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PENDIENTE', 'MOD_PENDIENTE: '||IDPENDIENTE||'', SYSDATE(), RSP);
                        
                        RETURN;
                                        
                           
                       
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PENDIENTE', 'MOD_PENDIENTE: '||IDPENDIENTE||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/



--MOD PLUVIOMETRIA 
create or replace PROCEDURE "SP_MOD_PLUVIOMETRIA"

            (IDPLUVIOMETRIA IN NUMBER,
            CONDICIONACTUAL IN VARCHAR,
            CONDICIONPASADA IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ERRORACTUAL EXCEPTION;
            ERRORPASADA EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
        -- EL CAMPO CONDICIONACTUAL SOLO PUEDE TENER LOS VALORES SU, PC, OV, RA, SL y SN SEGN LA MEMORIA.
        -- EL CAMPO CONDICIONPASADA HA DE SER UN VALOR ENTRE 1 Y 6.
        
        --CONTROL DE ENTRADA

  
        IF ((CONDICIONACTUAL <> 'SU') AND (CONDICIONACTUAL <> 'PC') AND (CONDICIONACTUAL <> 'OV') AND (CONDICIONACTUAL <> 'RA') AND (CONDICIONACTUAL <> 'SL') AND (CONDICIONACTUAL <> 'SN'))   THEN RAISE ERRORACTUAL;
        END IF;
 
 
        IF ((CONDICIONPASADA < 1) OR (CONDICIONPASADA > 6)) THEN RAISE ERRORPASADA;
            END IF;
            
            -- SI HE LLEGADO HASTA AQUI LOS DATOS SON CORRECTOS. ACTUALIZO DATOS EN PLUVIOMETRIA
            
                UPDATE SCCI_PLUVIOMETRIA SET
                CONDICIONACTUAL = CONDICIONACTUAL,
                CONDICIONPASADA = CONDICIONPASADA
                WHERE (IDPLUVIOMETRIA = IDPLUVIOMETRIA);
                
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLUVIOMETRIA', 'MOD_PLUVIOMETRIA: '||IDPLUVIOMETRIA||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                
                WHEN ERRORACTUAL THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DE LAS CONDICIONES ACTUALES NO SON CORRECTOS. DEBE SER UN VALOR: SU, PC, OV,RA, SL O SN. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLUVIOMETRIA', 'MOD_PLUVIOMETRIA: '||IDPLUVIOMETRIA||'', SYSDATE(), RSP);
                        
                        RETURN;
    
               WHEN ERRORPASADA THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DE LAS CONDICIONES PASADAS NO SON CORRECTOS. DEBE SER UN NMERO DEL 1 AL 6. CONSULTE LOS DATOS VALIDOS';

                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLUVIOMETRIA', 'MOD_PLUVIOMETRIA: '||IDPLUVIOMETRIA||'', SYSDATE(), RSP);
                        
                        RETURN;
                                        
                           
                       
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLUVIOMETRIA', 'MOD_PLUVIOMETRIA: '||IDPLUVIOMETRIA||'', SYSDATE(), RSP);
                  
                          RETURN;
                          
END;
END;

/






--MOD EROSION 
create or replace PROCEDURE "SP_MOD_EROSION"

            (IDEROSION IN NUMBER,
            AFECTACION IN NUMBER,
            GRADO IN VARCHAR,
            PERIODO IN VARCHAR,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ERRORAFECTACION EXCEPTION;
            ERRORGRADO EXCEPTION;
            ERRORPERIODO EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
        -- EL CAMPO AFECTACION SOLO PUEDE TENER VALORES ENTRE 0 Y 5
        -- EL CAMPO GRADO SOLO PUEDE TENER LOS VALORES S, M, V y E SEGN LA MEMORIA.
        -- EL CAMPO PERIODO SOLO PUEDE TENER LOS VALORES A, R, M, N y X SEGN LA MEMORIA.
        
        --CONTROL DE ENTRADA

  
        IF ((GRADO <> 'S') AND (GRADO <> 'M') AND (GRADO <> 'V') AND (GRADO <> 'E'))   THEN RAISE ERRORGRADO;
        END IF;
 
        IF ((PERIODO <> 'A') AND (PERIODO <> 'R') AND (PERIODO <> 'M') AND (PERIODO <> 'N') AND (PERIODO <> 'X'))   THEN RAISE ERRORPERIODO;
        END IF;
  
        IF ((AFECTACION < 0) OR (AFECTACION > 5)) THEN RAISE ERRORAFECTACION;
        END IF;
            
            -- SI HE LLEGADO HASTA AQUI LOS DATOS SON CORRECTOS. ACTUALIZO DATOS EN EROSION
            
            
                UPDATE SCCI_EROSION SET
                AFECTACION = AFECTACION,
                GRADO = GRADO,
                PERIODO = PERIODO
                WHERE (IDEROSION = IDEROSION);
                
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'MOD_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
              
              
                RETURN;
     
                        
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION

                WHEN ERRORAFECTACION THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DE LA AFECTACION ACTUALES NO SON CORRECTOS. DEBE SER UN NUMERO DEL 1 AL 5. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'MOD_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
                        
                        RETURN;
    
               WHEN ERRORGRADO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS LOS GRADOS DEBEN ESTAR ENTRE: S, M, V y E. LOS INTRODUCIDOS NO SON CORRECTOS. CONSULTE LOS DATOS VALIDOS';

                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'MOD_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
                        
                        RETURN;

              WHEN ERRORPERIODO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS LOS PERIODOS DEBEN ESTAR ENTRE: A, R, M, N y X. LOS INTRODUCIDOS NO SON CORRECTOS. CONSULTE LOS DATOS VALIDOS';

                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'MOD_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
                        
                        RETURN;             
                           
                       
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EROSION', 'MOD_EROSION: '||IDEROSION||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/




--MOD RIESGO 
create or replace PROCEDURE "SP_MOD_RIESGO"

            (IDRIESGO IN NUMBER,
            IDVEGETACION IN NUMBER,
            IDDENSIDAD IN NUMBER,
            IDPENDIENTE IN NUMBER,
            IDPLUVIOMETRIA IN NUMBER,
            IDEROSION IN NUMBER,
            VALORRIESGO IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            RESPUESTA CHAR;
            
            BEGIN
        
             
            -- TODOS LOS CONTROLES SE HACEN POR RELACIONES O POR EL TIPO DE CAMPO. NO HACE FALTA UN CONTROL ADICIONAL.
            
            
                UPDATE SCCI_RIESGO SET
                IDVEGETACION = IDVEGETACION,
                IDDENSIDAD = IDDENSIDAD,
                IDPENDIENTE = IDPENDIENTE,
                IDPLUVIOMETRIA = IDPLUVIOMETRIA,
                IDEROSION = IDEROSION,
                VALORRIESGO = VALORRIESGO
                WHERE (IDRIESGO = IDRIESGO);

        -- ACTUALIZO ESTADISTICA POR SI CAMBIA EL VALORRIESGO
            SP_ESTADISTICA_8(RESPUESTA);
            
        -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'RIESGO', 'MOD_RIESGO: '||IDRIESGO||'', SYSDATE(), RSP);
              
              
                RETURN;
                      
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                                      
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'RIESGO', 'MOD_RIESGO: '||IDRIESGO||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/


--MOD INCENDIO 
create or replace PROCEDURE "SP_MOD_INCENDIO"

            (IDINCENDIO IN NUMBER,
            IDPARCELA IN NUMBER,
            FECHA IN DATE,
            DAO IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            ANUALIDADLOCAL NUMBER;
            IDPARCELALOCAL NUMBER(10,0);
            RESPUESTA VARCHAR(1000);
            
            BEGIN
        
        
                -- ACTUALIZO LA ESTADISTICA 1 EN UNA VARIABLE LOCAL
            ANUALIDADLOCAL:= EXTRACT (YEAR FROM FECHA);
            
     
            -- COPIO LA PARCELA EN UNA VARIABLE LOCAL
            IDPARCELALOCAL := IDPARCELA;
        
      

              
            -- TODOS LOS CONTROLES SE HACEN POR RELACIONES O POR EL TIPO DE CAMPO. NO HACE FMOD UN CONTROL ADICIONAL.
            --ASIGNO AUTOMATICAMENTE LA ANUALIDAD EN FUNCION DE LA FECHA ASIGNADA
       
                        
                UPDATE SCCI_INCENDIO SET
                IDPARCELA = IDPARCELA,
                FECHA = FECHA,
                DAO = DAO,
                ANUALIDAD = ANUALIDADLOCAL
                WHERE (IDINCENDIO = IDINCENDIO);

            -- LLAMO AL PROCEDIMIENTO CON LAS VARIABLES LOCALES PARA ACTUALIZAR LAS ESTADISTICAS
            -- EN BASE A LOS DATOS PASADOS COMO PARAMETRO
              
              SP_ESTADISTICA_1(ANUALIDADLOCAL, IDPARCELALOCAL, RESPUESTA);
              SP_ESTADISTICA_3(RESPUESTA);
              SP_ESTADISTICA_5(RESPUESTA);
              SP_ESTADISTICA_7(RESPUESTA); 
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN
  

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'INCENDIO', 'MOD_INCENDIO: '||IDINCENDIO||'', SYSDATE(), RSP);
                      
              
                RETURN;
                      
              
                -- EN CASO DE ERROR O DATOS INCORRECTOS:         
                EXCEPTION
                                      
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'INCENDIO', 'MOD_INCENDIO: '||IDINCENDIO||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/





--MOD EMPRESA 
create or replace PROCEDURE "SP_MOD_EMPRESA"

            (IDEMPRESA IN NUMBER,
            NOMBRE IN VARCHAR,
            CIF IN VARCHAR,
            DIRECCION IN VARCHAR,
            TELEFONO IN VARCHAR,
            HOMOLOGADA IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        
        
                        
                UPDATE SCCI_EMPRESA SET
                NOMBRE = NOMBRE,
                CIF = CIF,
                DIRECCION = DIRECCION,
                TELEFONO = TELEFONO,
                HOMOLOGADA = HOMOLOGADA
                WHERE (IDEMPRESA = IDEMPRESA);
                
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EMPRESA', 'MOD_EMPRESA: '||IDEMPRESA||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'EMPRESA', 'MOD_EMPRESA: '||IDEMPRESA||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
END;

/


--MOD PLAN
create or replace PROCEDURE "SP_MOD_PLAN"

            (IDPLAN IN NUMBER,
            NOMBRE IN VARCHAR,
            ANUALIDAD IN VARCHAR,
            EFECTIVIDAD IN NUMBER,
            RSP OUT CHAR
            )
            
            IS
            BEGIN
            DECLARE 
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            
            BEGIN
        


                UPDATE SCCI_PLAN SET
                NOMBRE = NOMBRE,
                ANUALIDAD = ANUALIDAD,
                EFECTIVIDAD = EFECTIVIDAD
                WHERE (IDPLAN = IDPLAN);
                
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

   

                --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLAN', 'MOD_PLAN: '||IDPLAN||'', SYSDATE(), RSP);
              
              
                RETURN;
              
                -- EN CASO DE ERROR              
                EXCEPTION
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PLAN', 'MOD_PLAN: '||IDPLAN||'', SYSDATE(), RSP);
                  
                          RETURN;
                          


     
END;
END;

/


--MOD SUBVENCION 
create or replace PROCEDURE "SP_MOD_SUBVENCION"

            (VIDSUBVENCION IN NUMBER,
            VIDPLAN IN NUMBER,
            VFECHAINICIO IN DATE,
            VFECHAFINAL IN DATE,
            VESTADO IN NUMBER, 
            VIMPORTEMAX IN NUMBER,
            VGASTOACTUAL IN NUMBER, 
            RSP OUT VARCHAR
            )
            
            IS
            BEGIN
            DECLARE
            ERRORESTADO EXCEPTION;
            ERRORGASTO EXCEPTION;
            ERRORANUALIDAD EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            PROPIETARIOPARCELA NUMBER(10,0);
            ANUALIDADACTUAL VARCHAR(20);
            ANUALIDADPLAN VARCHAR(20);
            HAYDATOS NUMBER(10,0):=NULL;
            VANUALIDAD NUMBER;
                    
          
            BEGIN
            
            -- COMPRUEBO QUE LOS DATOS INTRODUCIDOS SEAN CORRECTOS
            
            -- OBTENGO EL AO ACTUAL EN CURSO
            SELECT EXTRACT(YEAR FROM sysdate) INTO ANUALIDADACTUAL FROM dual;
            
            -- BUSCO LA ANUALIDAD A LA QUE PERTENECE EL PLAN INTRODUCIDO
            SELECT COUNT(*) INTO HAYDATOS FROM SCCI_PLAN WHERE IDPLAN = VIDPLAN AND ACTIVO = 1;
            
            IF (HAYDATOS  <> 0) THEN
                 SELECT ANUALIDAD INTO ANUALIDADPLAN FROM SCCI_PLAN WHERE IDPLAN = VIDPLAN AND ACTIVO = 1;
                HAYDATOS := NULL;
            END IF;
        
        
        -- COMPRUEBO QUE EL PLAN PARA EL QUE CREO LA SUBVENCION SEA DE ESTE AO
                IF (ANUALIDADACTUAL <> ANUALIDADPLAN) THEN RAISE ERRORANUALIDAD;
                END IF;



        -- COMPRUEBO QUE NO SE HAYA PUESTO NADA EXTRAO EN ESTADO
        -- LOS VALORES SERIAN:
        --    ESTADO =1 : EN PROCESO DE ADJUDICACION
        --    ESTADO =2 : ADJUDICADA
        --    ESTADO =3 : FINALIZADA
        --    ESTADO =4 : CANCELADA
            
          IF ((VESTADO < 0) OR (VESTADO > 3)) THEN RAISE ERRORESTADO;
           END IF;
            
     
                
        --POR OTRO LADO NO DEBO DEJAR INTRODUCIR GASTO EN AQUELLAS SITUACIONES EN LAS QUE LA SUBVENCION NO ESTA ADJUDICADA.
        --ES DECIR SOLO SE PUEDE INTRODUCIR GASTO SI EL ESTADO ES 2

        IF ((VGASTOACTUAL <> 0) AND (VESTADO <> 2)) THEN RAISE ERRORGASTO;
        END IF;
        
        
        VANUALIDAD:=EXTRACT(YEAR FROM VFECHAINICIO);

                UPDATE SCCI_SUBVENCION SET
                IDPLAN = VIDPLAN,
                FECHAINICIO = VFECHAINICIO,
                FECHAFINAL = VFECHAFINAL,
                ESTADO = VESTADO,
                IMPORTEMAX = VIMPORTEMAX,
                GASTOACTUAL = VGASTOACTUAL,
                ANUALIDAD = VANUALIDAD
                WHERE (IDSUBVENCION = IDSUBVENCION);
                
                
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'MOD_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                

                WHEN ERRORESTADO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DEL ESTADO NO SON CORRECTOS. DEBE SER UN NUMERO DEL 1 AL 3. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'MOD_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                        
                        RETURN;
                  
                  
                  
                  WHEN ERRORGASTO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: EL ESTADO ACTUAL DE LA SUBVENCION NO PERMITE INTRODUCIR GASTOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'MOD_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                        
                        RETURN;
           
                    WHEN ERRORANUALIDAD THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: EL PLAN SELECCIONADO NO ES PARA EL AO' || ANUALIDADACTUAL;
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'MOD_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                        
                        RETURN;
    
                     WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'SUBVENCION', 'MOD_SUBVENCION: '||VIDSUBVENCION||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
                          
END;

/




--MOD TRABAJOS 
create or replace PROCEDURE "SP_MOD_TRABAJOS"

            (VIDTRABAJO IN NUMBER,
            VIDSUBVENCION IN NUMBER,
            VIDEMPRESA IN NUMBER,
            VFECHAASIGNACION IN DATE,
            VESTADO IN NUMBER,
            RSP OUT VARCHAR
            )
            
            IS
            BEGIN
            DECLARE
            ERRRORHOMOLOGADA EXCEPTION;
            ERRORESTADOSUBVENCION EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            ESTADOHOMOLOGACION NUMBER(1);
            ESTADOSUBVENCION NUMBER(1);
            HAYDATOS NUMBER(10,0):=NULL;
            
                    
          
            BEGIN
    
            
        -- HE DE COMPROBAR QUE LA EMPRESA EST HOMOLOGADA. SINO NO LE PUEDO ASIGNAR TRABAJOS
        
        --EVITA ERROR DE QUE NO HAYA DATOS Y SALTE LA EXCEPCION
        
        SELECT COUNT(*) INTO HAYDATOS FROM SCCI_EMPRESA WHERE IDEMPRESA = VIDEMPRESA AND ACTIVO = 1;
        
        IF (HAYDATOS <> 0) THEN
             SELECT HOMOLOGADA INTO ESTADOHOMOLOGACION FROM SCCI_EMPRESA WHERE IDEMPRESA = VIDEMPRESA AND ACTIVO = 1;
             HAYDATOS := NULL;
        END IF;
        
        
        -- SI LA EMPRESA NO ESTA HOMOLOGADA NO SE PUEDE ASIGNAR LA SUBVENCION
        IF (ESTADOHOMOLOGACION <> 1) THEN RAISE ERRRORHOMOLOGADA;
        END IF;

        -- HE DE COMPROBAR QUE LA SUBVENCION EST ACEPTADA. SINO NO LE PUEDO ASIGNAR UNA EMPRESA
             SELECT COUNT(*) INTO HAYDATOS FROM SCCI_SUBVENCION WHERE IDSUBVENCION = VIDSUBVENCION;
        
        IF (HAYDATOS <> 0) THEN
             SELECT ESTADO INTO ESTADOSUBVENCION FROM SCCI_SUBVENCION WHERE IDSUBVENCION = VIDSUBVENCION;
            HAYDATOS := NULL;
        END IF;
        
        -- SI LA SUBVENCION NO ESTA ADJUDICADA = 2. NO SE PUEDE ASIGNAR LA SUBVENCION
        IF (ESTADOSUBVENCION <> 2) THEN RAISE ERRORESTADOSUBVENCION;
        END IF;
            
            
        --SINO LE ASIGNO LA SUBVENCION A LA EMPRESA QUE TRABAJARA


                UPDATE SCCI_TRABAJOS SET
                IDSUBVENCION = VIDSUBVENCION,
                IDEMPRESA  = VIDEMPRESA,
                FECHAASIGNACION  = VFECHAASIGNACION,
                ESTADO = VESTADO
                WHERE (IDTRABAJO = IDTRABAJO);
                
                
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'TRABAJOS', 'MOD_TRABAJOS: '||VIDTRABAJO||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                

                WHEN ERRRORHOMOLOGADA THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LA EMPRESA TIENE QUE ESTAR HOMOLOGADA PARA ASIGNARLE UN TRABAJO';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'TRABAJOS', 'MOD_TRABAJOS: '||VIDTRABAJO||'', SYSDATE(), RSP);
                        
                        RETURN;
                  
                  
                  
                  WHEN ERRORESTADOSUBVENCION THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: EL ESTADO ACTUAL DE LA SUBVENCION NO PERMITE SU ASIGNACION. TIENE QUE ESTAR ADJUDICADA Y NO FINALIZADA.';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'TRABAJOS', 'MOD_TRABAJOS: '||VIDTRABAJO||'', SYSDATE(), RSP);
                        
                        RETURN;
    
    
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'TRABAJOS', 'MOD_TRABAJOS: '||VIDTRABAJO||'', SYSDATE(), RSP);
                  
                        RETURN;
                          
END;
                          
END;

/



--MOD PETICION 
create or replace PROCEDURE "SP_MOD_PETICION"
        (VIDPETICION IN NUMBER,
            VIDPROPIETARIO IN NUMBER,
            VIDPARCELA IN NUMBER,
            VIDSUBVENCION IN NUMBER,
            VFECHAPETICION IN DATE,
            VRESOLUCION IN NUMBER,
            VFECHARESOLUCION IN DATE,
            ANUALIDAD IN NUMBER,
            RSP OUT VARCHAR
            )
            
            IS
            BEGIN
            DECLARE
            ERRORPROPIETARIO EXCEPTION;
            ERRORESTADO EXCEPTION;
            ERRORDUPLICADO EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            PROPIETARIOPARCELA NUMBER(10,0);
            RESOLUCIONDEFECTO NUMBER(1);
            FECHARESOLUCIONDEFECTO DATE;   
            PETICIONDUPLICADA NUMBER(10,0);
            HAYDATOS NUMBER(10,0);
            
            BEGIN
            
            
        --INTRODUZCO VALORES POR DEFECTO
        
            PETICIONDUPLICADA := NULL;
            HAYDATOS := NULL;
            
        -- COMPRUEBO QUE NO SE HAYA PUESTO NADA EXTRAO EN ESTADO
        -- LOS VALORES SERIAN:
        --    ESTADO =1 : SOLICITADA Y POR TANTO EN CURSO DE ADJUDICACION
        --    ESTADO =2 : ADJUDICADA O ACEPTADA
        --    ESTADO =3 : RECHAZADA O FINALIZADA
            
           IF ((VRESOLUCION < 0) OR (VRESOLUCION > 3)) THEN RAISE ERRORESTADO;
            END IF;
   
        --HE DE COMPROBAR QUE LA PARCELA INTRODUCIDA CORRESPONDE AL PROPIETARIO INTRODUCIDO.
        --DE OTRA MANERA SE PODRIA ASIGNAR UNA SUBVENCION A UN PROPIETARIO PARA UNA PARCELA QUE NO FUERA SUYA
     
             
              SELECT COUNT(*) INTO HAYDATOS FROM SCCI_PARCELA WHERE (IDPARCELA = VIDPARCELA);
             
        IF (HAYDATOS <> 0) THEN
           
            SELECT IDPROPIETARIO INTO PROPIETARIOPARCELA FROM SCCI_PARCELA WHERE (IDPARCELA = VIDPARCELA);
         HAYDATOS := NULL;
         END IF;

        -- SINO CONCUERDA EL PROPIETARIO DE LA PARCELA CON EL INTRODUCIDO INICIA ERROR. 
        -- NO SE PUEDE GENERAR UNA PETICION SI UN PROPIETARIO NO ES EL VERDADERO PROPIETARIO DE LA PARCELA 

        IF (PROPIETARIOPARCELA <> VIDPROPIETARIO) THEN RAISE ERRORPROPIETARIO;
        END IF;
         
        --COMPRUEBO QUE EL PROPIETARIO PARA ESA PARCELA NO TIENE YA UNA PETICION PENDIENTE
        
        SELECT COUNT(*) INTO HAYDATOS FROM SCCI_PETICION WHERE ((IDPROPIETARIO = VIDPROPIETARIO) AND (IDPARCELA=VIDPARCELA) AND (IDSUBVENCION = VIDSUBVENCION));
        
         IF (HAYDATOS <> 0) THEN RAISE ERRORDUPLICADO;
         END IF;

         -- ACTUALIZO LA PETICION CON LOS NUEVOS DATOS
         -- SIN EMBARGO, ESTE PROCEDIMIENTO SE HA DE EJECUTAR SOLO EN CASO DE QUERER CAMBIAR LOS DATOS POR ERROR
         -- EL RESULTADO DE UNA RESOLUCION DE UNA PETICION SE DEBERIA EJECUTAR CON EL SP_RESOLVER_PETICION
         -- TAMBIEN SE PODRIA HACER CON ESTE MISMO. PERO HABRIA QUE INTRODUCIR MAS DATOS QUE UNICAMENTE LA PETICION ACEPTADA.
                UPDATE SCCI_PETICION SET
                IDPROPIETARIO = VIDPROPIETARIO,
                IDPARCELA  = VIDPARCELA,
                IDSUBVENCION  = VIDSUBVENCION,
                FECHAPETICION = VFECHAPETICION,
                RESOLUCION = VRESOLUCION,
                FECHARESOLUCION = VFECHARESOLUCION
                WHERE (IDPETICION = IDPETICION);
            
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            --REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'MOD_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                

                WHEN ERRORESTADO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DEL ESTADO NO SON CORRECTOS. DEBE SER UN NUMERO DEL 1 AL 3. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'MOD_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
                        
                        RETURN;
                  
                  
                  
                WHEN ERRORDUPLICADO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: UN PROPIETARIO NO PUEDE SOLICITAR PARA UNA MISMA PARCELA LA MISMA SUBVENCION DOS VECES';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'MOD_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
                        
                        RETURN;
                  
                  
                  
                  WHEN ERRORPROPIETARIO THEN
                
                   -- MODIFICO LA ENTRADA EN EL LOG DICIENDO QUE HAN ENTRADO DATOS NO VALIDOS
                        RSP:= 'ERROR: LOS DATOS DE LA PARCELA NO SE CORRESPONDEN CON EL PROPIETARIO DE LA MISMA INTRODUCIDO. CONSULTE LOS DATOS VALIDOS';
                          
                
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                       INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'MOD_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
                        
                        RETURN;
    
                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
             -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                      SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'PETICION', 'MOD_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
     
                        RETURN;
                          
END;
                          
END;

/


