-- ADJUDICA UNA SUBVENCIONA UNA PETICION.
-- DE UN LISTADO DE PETICIONES PARA UNA SUBVENCION SE ADJUDICA LA SUBVENCION A UNA DE ELLAS RECHAZANDO LAS DEMAS

create or replace PROCEDURE "SP_RESOLVER_PETICION"
        (VIDPETICION IN NUMBER,
        RSP OUT VARCHAR
        )
            
            IS
            BEGIN
            DECLARE
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            HAYDATOS NUMBER(10,0);
            SUBVENCION NUMBER(10,0);
            ANUALIDAD NUMBER;
            FECHA DATE;
            FECHAACTUAL DATE;
            RESPUESTA VARCHAR(500);
            
            BEGIN
        
            --OBTENGO LA FECHA ACTUAL DE LA OPERACION
             SELECT CURRENT_DATE INTO FECHAACTUAL FROM DUAL;
            
            --CONSULTO LA SUBVENCION PARA LA QUE SE HABIA PEDIDO LA PETICION
                SELECT IDSUBVENCION INTO SUBVENCION FROM SCCI_PETICION WHERE (IDPETICION = VIDPETICION);
            
            -- RECHAZO TODAS LAS PETICIONES PARA ESA SUBVENCION
                UPDATE SCCI_PETICION SET
                RESOLUCION = 3, --RECHAZADA
                FECHARESOLUCION = FECHAACTUAL
                WHERE (IDSUBVENCION = SUBVENCION);
            
            -- ADJUDICO LA PETICION ACEPTADA A LA SUBVENCION
                UPDATE SCCI_PETICION SET
                RESOLUCION = 2, --ACEPTADA
                FECHARESOLUCION = FECHAACTUAL
                WHERE (IDPETICION = VIDPETICION);
            
            -- UNA VEZ ADJUDICADA POR SIMPLICIDAD EN LAS CONSULTAS COMO SE DESCRIBE EN LA MEMORIA
            -- ACTUALIZO EL CAMPO PETICIONGANADORA EN LA TABLA DE SUBVENCIONES PARA NO TENER QUE CONSULTAR LA PETICION QUE LE CORRESPONDE A LA SUBVENCION.
            -- POR ULTIMO ACTUALIZO EL CAMPO ESTADO DE LA SUBVENCION PARA DEJARLA ADJUDICADA Y QUE PUEDA ACEPTAR GASTO     
                UPDATE SCCI_SUBVENCION SET
                IDPETICIONGANADORA = VIDPETICION,
                ESTADO = 2
                WHERE (IDSUBVENCION = SUBVENCION);
                
                
                
            --EXTRAIGO LA ANUALIDAD DE LA PETICION
            SELECT FECHAPETICION INTO FECHA FROM SCCI_PETICION WHERE IDPETICION = VIDPETICION;
            ANUALIDAD:= EXTRACT (YEAR FROM FECHA);
            
            -- ACTUALIZO ESTADISTICAS
            SP_ESTADISTICA_4(ANUALIDAD, RESPUESTA);
            SP_ESTADISTICA_9(RESPUESTA);
                
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            -- REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'OPERACION_ESPECIAL', 'RESOLUCION_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION

                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
                     -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'OPERACION_ESPECIAL', 'RESOLUCION_PETICION: '||VIDPETICION||'', SYSDATE(), RSP);
     
                        RETURN;
                          
END;
                          
END;

/

-- ASIGNA UNA EMPRESA A UNA SUBVENCION
-- DE UN LISTADO DE EMPRESAS SE ASIGNA UNA PARA QUE REALIZE LOS TRABAJOS PLANIFICADOS EN UNA SUBVENCION ACEPTADA

create or replace PROCEDURE "SP_ASIGNACION_EMPRESA"
        (VIDSUBVENCION IN NUMBER,
        VIDEMPRESA IN NUMBER,
        RSP OUT VARCHAR
        )
            
            IS
            BEGIN
            DECLARE
            ERRORSUBVENCION EXCEPTION;
            ERROREMPRESA EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ULTIMOREGISTRO NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            SUBVENCIONVALIDA NUMBER(1);
            EMPRESAVALIDA NUMBER(1);
            
            
            BEGIN
            SUBVENCIONVALIDA:=0; -- POR DEFECTO LA SUBVENCION INTRODUCIDA NO ES VALIDA
            EMPRESAVALIDA:=0; -- POR DEFECTO LA EMPRESA SELECCIONADA NO ES VALIDA
            
            
            -- CONSULTO LA SUBVENCION PARA VER SI EXISTE Y ADEMAS ESTA ACEPTADA. ES DECIR, SE HA DICTADO UNA RESOLUCION EN UNA DE LAS PETICIONES PONIENDO SU ESTADO A = 2 (ADJUDICADA)
            SELECT COUNT(*) INTO SUBVENCIONVALIDA FROM SCCI_SUBVENCION WHERE ((IDSUBVENCION = VIDSUBVENCION) AND (ESTADO = 2));
            -- SI CUMPLE LAS CONDICIONES SUBVENCIONVALIDA = 1 (RESULTADO DE LA CONSULTA). SI SIGUE SIENDO 0 LA EMPRESA NO ES CORRECTA
            IF (SUBVENCIONVALIDA = 0) THEN RAISE ERRORSUBVENCION;
            END IF;
            
            -- CONSULTO LA EMPRESA PARA VER SI EXISTE Y ADEMAS ESTA HOMOLOGADA
            SELECT COUNT(*) INTO EMPRESAVALIDA FROM SCCI_EMPRESA WHERE ((IDEMPRESA = VIDEMPRESA) AND (HOMOLOGADA = 1));
            -- SI CUMPLE LAS CONDICIONES EMPRESAVALIDA = 1 (RESULTADO DE LA CONSULTA) SI SIGUE SIENDO 0 LA EMPRESA NO ES CORRECTA
            IF (EMPRESAVALIDA = 0) THEN RAISE ERROREMPRESA;
            END IF;
            
            -- SI ESTOY AQUI ES PORQUE LA SUBVENCION Y LA EMPRESA SON VALIDAS PARA ASIGNARSE
            
            -- BUSCO EL ULTIMO REGISTRO DE LA TABLA TRABAJOS
                SELECT MAX(IDTRABAJO) INTO ULTIMOREGISTRO FROM SCCI_TRABAJOS;
                IF(ULTIMOREGISTRO IS NULL) THEN ULTIMOREGISTRO:=1;
                ELSE ULTIMOREGISTRO := ULTIMOREGISTRO +1;
                END IF;
                
            -- CREO LA ASIGNACION CON LA FECHA ACTUAL Y EL ESTADO EN CURSO
               INSERT INTO SCCI_TRABAJOS VALUES (ULTIMOREGISTRO, VIDEMPRESA, VIDSUBVENCION, SYSDATE(), 1);
                
                
                
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            -- REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'OPERACION_ESPECIAL', 'ASIGNACION_EMPRESA: '||VIDSUBVENCION||'-'||VIDEMPRESA, SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                
                 WHEN ERRORSUBVENCION THEN
                               
                          RSP:= 'ERROR: LA SUBVENCION' || VIDSUBVENCION || 'NO EXISTE O NO EST ADJUDICADA' ; 
                          
                      -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'OPERACION_ESPECIAL', 'ASIGNACION_EMPRESA: '||VIDSUBVENCION||'-'||VIDEMPRESA, SYSDATE(), RSP);
     
                        RETURN;
                        
                        
                         

                 WHEN ERROREMPRESA THEN
                               
                          RSP:= 'ERROR: LA EMPRESA' || VIDEMPRESA || 'NO EXISTE O NO EST HOMOLOGADA' ; 
                          
                      -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'OPERACION_ESPECIAL', 'ASIGNACION_EMPRESA: '||VIDSUBVENCION||'-'||VIDEMPRESA, SYSDATE(), RSP);
     
                        RETURN;

                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
                        -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'OPERACION_ESPECIAL', 'ASIGNACION_EMPRESA: '||VIDSUBVENCION||'-'||VIDEMPRESA, SYSDATE(), RSP);
     
                        RETURN;
                          
END;
                          
END;

/


-- ADJUDICA UNA SUBVENCIONA UNA PETICION.
-- DE UN LISTADO DE PETICIONES PARA UNA SUBVENCION SE ADJUDICA LA SUBVENCION A UNA DE ELLAS RECHAZANDO LAS DEMAS

create or replace PROCEDURE "SP_INTRODUCIR_GASTO"
        (VIDSUBVENCION IN NUMBER,
        NUEVOGASTO IN NUMBER,
        RSP OUT VARCHAR
        )
            
            IS
            BEGIN
            DECLARE
            ERRORSUBVENCION EXCEPTION;
            ERRORLIMITEGASTO EXCEPTION;
            ULTIMONUMLOG NUMBER(10,0);
            ERR_NUM NUMBER(10,0);
            ERR_MSG VARCHAR(255);
            SUBVENCIONVALIDA NUMBER(1);
            LIMITEGASTO NUMBER(10,2);
            GASTOHISTORICO NUMBER(10,2);
            GASTOTOTAL NUMBER(10,2);
            RESPUESTA VARCHAR(500);
         
            BEGIN
            SUBVENCIONVALIDA:=0; -- POR DEFECTO LA SUBVENCION INTRODUCIDA NO ES VALIDA
        
            -- CONSULTO LA SUBVENCION PARA VER SI EXISTE Y ADEMAS ESTA ACEPTADA. ES DECIR, SE HA DICTADO UNA RESOLUCION EN UNA DE LAS PETICIONES PONIENDO SU ESTADO A = 2 (ADJUDICADA)
            SELECT COUNT(*) INTO SUBVENCIONVALIDA FROM SCCI_SUBVENCION WHERE ((IDSUBVENCION = VIDSUBVENCION) AND (ESTADO = 2));
            -- SI CUMPLE LAS CONDICIONES SUBVENCIONVALIDA = 1 (RESULTADO DE LA CONSULTA). SI SIGUE SIENDO 0 LA EMPRESA NO ES CORRECTA
            IF (SUBVENCIONVALIDA = 0) THEN RAISE ERRORSUBVENCION;
            END IF;
            
            -- EN ESTE PUNTO SE QUE LA SUBVENCION ES VALIDA Y ADJUDICADA POR LO QUE PUEDE TENER GASTO.
            -- COMPRUEBO ENTONCES SI LA SUMA DEL NUEVO GASTO AL QUE HABIA SUPERA EL LIMITE
            SELECT IMPORTEMAX INTO LIMITEGASTO FROM SCCI_SUBVENCION WHERE (IDSUBVENCION = VIDSUBVENCION);
            SELECT GASTOACTUAL INTO GASTOHISTORICO FROM SCCI_SUBVENCION WHERE (IDSUBVENCION = VIDSUBVENCION);
            
            
            -- TIENE QUE CUMPLIR QUE EL NUEVO GASTO + EL GASTOHISTORICO < LIMITE GASTO
            GASTOTOTAL:=(NUEVOGASTO + GASTOHISTORICO);
            IF ( GASTOTOTAL > LIMITEGASTO) THEN RAISE ERRORLIMITEGASTO;
            END IF;
            
            -- SI ESTOY AQUI ES PORQUE LA SUBVENCION ES VALIDA Y EL NUEVO GASTO NO SUPERA EL LIMITE
            
                   
            -- ACTUALIZO EL GASTOACTUAL DE LA SUBVENCION
           
                UPDATE SCCI_SUBVENCION SET
                GASTOACTUAL = GASTOTOTAL
                WHERE (IDSUBVENCION = VIDSUBVENCION);
                
            -- ACTUALIZO LA ESTADISTICA
            SP_ESTADISTICA_6(RESPUESTA);
                
            -- INSERTO LA OPERACION EN EL LOG
                RSP:='OK'; -- SINO INICIA LA EXCEPCION ES QUE TODO HA IDO BIEN

            -- REGISTRO EL ULTIMO REGISTRO DEL LOG
                SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                END IF;
                INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'OPERACION_ESPECIAL', 'INTRODUCCION_GASTO: '||VIDSUBVENCION||'-'||NUEVOGASTO, SYSDATE(), RSP);
                            
                RETURN;
                   
             -- EN CASO DE ERROR      
                EXCEPTION
                
                 WHEN ERRORSUBVENCION THEN
                               
                          RSP:= 'ERROR: LA SUBVENCION' || VIDSUBVENCION || 'NO EXISTE O NO EST ADJUDICADA' ; 
                          
                      -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'OPERACION_ESPECIAL', 'INTRODUCCION_GASTO: '||VIDSUBVENCION||'-'||NUEVOGASTO, SYSDATE(), RSP);

     
                        RETURN;
                        
                WHEN ERRORLIMITEGASTO THEN
                               
                          RSP:= 'ERROR: EL GASTO INTRODUCIDO EN LA' || VIDSUBVENCION || 'SUPERA EL MAXIMO PERMITIDO' ; 
                          
                      -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'OPERACION_ESPECIAL', 'INTRODUCCION_GASTO: '||VIDSUBVENCION||'-'||NUEVOGASTO, SYSDATE(), RSP);

     
                        RETURN;   
                         

                 WHEN OTHERS THEN
                          err_num := SQLCODE; 
                          err_msg := SQLERRM;	           
                          RSP:= 'ERROR:' || err_num || err_msg ; 
                          
                        -- MODIFICO ENTONCES LA ENTRADA EN EL LOG
                        SELECT MAX(IDLOG) INTO ULTIMONUMLOG FROM SCCI_LOG;
                        IF(ULTIMONUMLOG IS NULL) THEN ULTIMONUMLOG:=1;
                        ELSE ULTIMONUMLOG := ULTIMONUMLOG +1;
                        END IF;
                        INSERT INTO SCCI_LOG VALUES (ULTIMONUMLOG, 'OPERACION_ESPECIAL', 'INTRODUCCION_GASTO: '||VIDSUBVENCION||'-'||NUEVOGASTO, SYSDATE(), RSP);

     
                        RETURN;
                          
END;
                          
END;

/
 